## cppad 2021.00.00.8

=== CMakeLists.txt ===
# -----------------------------------------------------------------------------
# CppAD: C++ Algorithmic Differentiation: Copyright (C) 2003-21 Bradley M. Bell
#
# CppAD is distributed under the terms of the
#              Eclipse Public License Version 2.0.
#
# This Source Code may also be made available under the following
# Secondary License when the conditions for such availability set forth
# in the Eclipse Public License, Version 2.0 are satisfied:
#       GNU General Public License, Version 2.0 or later.
# -----------------------------------------------------------------------------
# =============================================================================
# Some constants
# =============================================================================
# Suppress warnging that WIN32 not defined on cygwin
SET(CMAKE_LEGACY_CYGWIN_WIN32 0) # remove when version below >= 2.8.4
#
# Set the minimum required version of cmake for this project.
# see http://www.cmake.org/pipermail/cmake/2013-January/053213.html
CMAKE_MINIMUM_REQUIRED(VERSION 2.8.4)
#
# https://gitlab.kitware.com/cmake/cmake/issues/17292
if(POLICY CMP0054)
  cmake_policy(SET CMP0054 NEW)
endif()
#
# cppad_version is used by version.sh to get the version number.
SET(cppad_version "20210000.8")
SET(cppad_url          "https://coin-or.github.io/CppAD" )
SET(cppad_description  "Differentiation of C++ Algorithms" )
#
# Set name of this project and create the variables
# cppad_BINARY_DIR and cppad_SOURCE_DIR.
# project(projectname [CXX] [C] [Java])
PROJECT(cppad)
#
# Add the include sub-directory to the list of C++ preprocessor
# include directories for the entire project.  The SYSTEM flag is not included
# so warnings will be geenreated for this directory.
INCLUDE_DIRECTORIES( ${cppad_SOURCE_DIR}/include )
#
# =============================================================================
# Some system cmake language extensions
# =============================================================================
# CHECK_CXX_SOURCE_COMPILES(source variable)
# Checks whether the code given in source will compile, link and run and
# return zero status. You can set
# CMAKE_REQUIRED_LIBRARIES, CMAKE_REQUIRED_FLAGS and CMAKE_REQUIRED_INCLUDES
# accordingly if additional libraries or compiler flags are required.
INCLUDE(CheckCXXSourceRuns)

# ============================================================================
# Some local cmake language
# ============================================================================
# assert_value_in_set(value element_1 ... element_n)
INCLUDE(cmake/assert_value_in_set.cmake)
#
# dos_path_to_unix(dos_path unix_path)
INCLUDE(cmake/dos_path_to_unix.cmake)
#
# add_to_list(variable_list constant_value)
INCLUDE(cmake/add_to_list.cmake)
#
# command_line_arg(variable default type description)
INCLUDE(cmake/command_line_arg.cmake)
#
# optional_package(package description)
INCLUDE(cmake/optional_package.cmake)
#
# run_source_test(source variable)
INCLUDE(cmake/run_source_test.cmake)
#
# assert(variable)
INCLUDE(cmake/assert.cmake)
#
# print_variable(variable)
INCLUDE(cmake/print_variable.cmake)
#
# set_compile_flags( program_name debug_which source_list)
INCLUDE(cmake/set_compile_flags.cmake)
#
# pkgconfig_info(name, system)
INCLUDE(cmake/pkgconfig_info.cmake)
# ============================================================================
# Check for c++11
SET(source "
int main(void)
{   if( __cplusplus < 201103 )
        return 1;
    return 0;
}"
)
run_source_test("${source}" cppad_cplusplus_201100_ok )
IF( NOT cppad_cplusplus_201100_ok  )
    SET(CMAKE_CXX_STANDARD 11)
    SET(CMAKE_CXX_STANDARD_REQUIRED ON)
ENDIF( NOT cppad_cplusplus_201100_ok  )
# =============================================================================
# command line arguments
# =============================================================================
# Argumentd that are no longer used
#
IF( cppad_sparse_list )
    MESSAGE(FATAL_ERROR
        "cppad_sparse_list has been removed from cmake command"
    )
ENDIF( cppad_sparse_list )
#
IF( cppad_deprecated )
    MESSAGE(FATAL_ERROR "cppad_deprecated has been removed from cmake comamnd" )
ENDIF( cppad_deprecated )
#
IF( cmake_install_prefix )
    MESSAGE(FATAL_ERROR
        "cmake_install_prefix has been changed to cppad_prefix"
    )
ENDIF( cmake_install_prefix )
#
IF( cmake_install_postfix )
    MESSAGE(FATAL_ERROR
        "cmake_install_postfix has been changed to cppad_postfix"
    )
ENDIF( cmake_install_postfix )
#
FOREACH(pkg adolc eigen ipopt cppadcg)
    IF( ${pkg}_prefix )
        MESSAGE(FATAL_ERROR
            "-D ${pkg}_prefix=value has been changed to -D include_${pkg}=true"
        )
    ENDIF( ${pkg}_prefix )
ENDFOREACH(pkg adolc eigen ipopt)
# -----------------------------------------------------------------------------
# Current Arguments
#
# cmake_install_datadir
command_line_arg(cmake_install_datadir share STRING
    "directory, below prefix, where cmake installs cppad data files"
)
#
# cmake_install_docdir
command_line_arg(cmake_install_docdir NOTFOUND STRING
    "directory, below prefix, where cmake installs cppad documentation files"
)
#
# cmake_install_includedirs
command_line_arg(cmake_install_includedirs include STRING
    "directories, below prefix, where cmake installs include files"
)
#
# cmake_install_libdirs
command_line_arg(cmake_install_libdirs lib STRING
    "directories, below prefix, where cmake installs library files"
)
#
# cppad_prefix
command_line_arg(cppad_prefix "${CMAKE_INSTALL_PREFIX}" PATH
    "cppad install prefix"
)
#
# cppad_postfix
command_line_arg(cppad_postfix NOTFOUND STRING
    "cppad install postfix"
)
#
# cppad_cxx_flags
command_line_arg(cppad_cxx_flags "" STRING
    "compile flags used with cppad (besides debug, release, and profile flags)"
)
#
# cppad_profile_flag
command_line_arg(cppad_profile_flag NOTFOUND STRING
    "compile flag used to compile and link a profile version of a program"
)
#
# cppad_testvector
command_line_arg(cppad_testvector cppad STRING
    "Namespace of vector used for testing, one of: boost, cppad, eigen, std"
)
assert_value_in_set(cppad_testvector boost cppad eigen std)
#
# cppad_max_num_threads
command_line_arg(cppad_max_num_threads 48 STRING
    "maximum number of threads that CppAD can use use"
)
#
# cppad_tape_id_type
command_line_arg(cppad_tape_id_type "unsigned int" STRING
    "type used to identify different tapes, size must be <= sizeof(size_t)"
)
#
# cppad_tape_addr_type
command_line_arg(cppad_tape_addr_type "unsigned int" STRING
"type used to identify variables on one tape, size must be <= sizeof(size_t)"
)
#
# cppad_debug_which
command_line_arg(cppad_debug_which "debug_all" STRING
    "debug_even, debug_odd, debug_all, or debug_none"
)
assert_value_in_set(cppad_debug_which debug_even debug_odd debug_all debug_none)
#
# include_eigen
# include_adolc
# include_ipopt
# include_cppadcg
FOREACH(package eigen adolc ipopt cppadcg)
    command_line_arg(include_${package} "false" BOOL
            "include the ${package} examples and tests"
    )
ENDFOREACH(package eigen adolc ipopt cppadcg)
# -----------------------------------------------------------------------------
# CMAKE_INSTALL_PREFIX
SET(CMAKE_INSTALL_PREFIX "${cppad_prefix}"
    CACHE PATH "value copied from cppad_prefix" FORCE
)
# -----------------------------------------------------------------------------
# External package information
SET(system_include TRUE)
#
# eigen
IF( include_eigen )
    pkgconfig_info(eigen3 ${system_include})
    SET(eigen_LIBRARIES "${eigen3_LIBRARIES}")
    SET(cppad_has_eigen 1)
ELSE( include_eigen )
    SET(cppad_has_eigen 0)
ENDIF( include_eigen )
#
# adolc
IF( include_adolc )
    pkgconfig_info(adolc ${system_include})
    SET(cppad_has_adolc 1)
ELSE( include_adolc )
    SET(cppad_has_adolc 0)
ENDIF( include_adolc )
#
# ipopt
IF( include_ipopt )
    pkgconfig_info(ipopt ${system_include})
    SET(cppad_has_ipopt 1)
ELSE( include_ipopt )
    SET(cppad_has_ipopt 0)
ENDIF( include_ipopt )
#
# cppadcg
IF( include_cppadcg )
    SET(cppad_has_cppadcg 1)
ELSE( include_cppadcg )
    SET(cppad_has_cppadcg 0)
ENDIF( include_cppadcg )
#
# colpack_prefix
optional_package(colpack ${system_include} "colpack install prefix")
#
# sacado_prefix
optional_package(sacado ${system_include} "sacado install prefix")
#
# fadbad_prefix
optional_package(fadbad ${system_include} "fadbad install prefix")
#
# xpackage_prefix is an example package prefix that is not really used
SET(xpackage_prefix "/usr")
# -----------------------------------------------------------------------------
# =============================================================================
# cppad_lib
# Perhaps in the future cppad_lib will depend on cmake header only flag ?
SET( cppad_lib    "cppad_lib" )
LINK_DIRECTORIES( ${cppad_BINARY_DIR}/cppad_lib )
# =============================================================================
# colpack_libs
#
IF( cppad_has_colpack )
    SET( colpack_libs "ColPack" )
ELSE( cppad_has_colpack )
    SET( colpack_libs "" )
ENDIF( cppad_has_colpack )
# =============================================================================
# automated system configuration
# =============================================================================
# CMAKE_CXX_FLAGS
IF( "${debug_which}" STREQUAL "debug_all" )
    print_variable(CMAKE_CXX_FLAGS_DEBUG)
ELSEIF( "${debug_which}" STREQUAL "debug_none" )
    print_variable(CMAKE_CXX_FLAGS_RELEASE)
ELSE( "${debug_which}" )
    print_variable(CMAKE_CXX_FLAGS_DEBUG)
    print_variable(CMAKE_CXX_FLAGS_RELEASE)
ENDIF( "${debug_which}" STREQUAL "debug_all" )
# -----------------------------------------------------------------------------
# cppad_abs_includedir, cppad_abs_libdir, cppad_abs_datadir, cppad_abs_docdir
#
# for dir_types = includedirs, libdirs, datadir, docdir
FOREACH(dir_types includedirs libdirs datadir docdir)
    # set dir_type = dir_types with  "dirs" -> "dir"
    STRING(REGEX REPLACE "dirs" "dir" dir_type ${dir_types})
    #
    # set dir_name to first directory in cmake_install_${dir_types}
    SET(dir_name NOTFOUND)
    FOREACH(dir ${cmake_install_${dir_types}})
        IF( NOT dir_name )
            SET(dir_name ${dir})
        ENDIF( NOT dir_name )
    ENDFOREACH(dir ${cmake_install_${dir_types}})
    #
    # set cppad_abs_${dir_type}
    SET(cppad_abs_${dir_type} "${cppad_prefix}/${dir_name}" )
    #
    # check if we need to add a postfix to it
    IF( cppad_postfix )
        SET(cppad_abs_${dir_type} ${cppad_abs_${dir_type}}/${cppad_postfix} )
    ENDIF( cppad_postfix )
ENDFOREACH(dir_types includedirs libdirs datadir docdir)
# -----------------------------------------------------------------------------
# OPENMP_FOUND, OpenMP_CXX_FLAGS
FIND_PACKAGE(OpenMP)
# -----------------------------------------------------------------------------
# boost_prefix
# Only need components for object libraries, not include libraries.
FIND_PACKAGE(Boost COMPONENTS thread)
SET(cppad_has_boost 0)
IF ( Boost_FOUND )
    SET(cppad_has_boost 1)
    #
    # Extract the Boost prefix from Boost_INCLUDE_DIRS
    #
    # convert to using unix directory separator
    dos_path_to_unix("${Boost_INCLUDE_DIRS}" boost_include_dirs)
    #
    # convert to just one directory
    STRING(REGEX REPLACE
        "([^ ]+).*" "\\1"
        boost_include_dir "${boost_include_dirs}"
    )
    #
    # extract part before last backslash
    STRING(REGEX REPLACE
        "([^ ]*)/[^/ ]*" "\\1"
        boost_prefix "${boost_include_dir}"
    )
    print_variable(boost_prefix)
    #
    # add boost include directories
    FOREACH(dir ${cmake_install_includedirs})
        IF( IS_DIRECTORY ${boost_prefix}/${dir} )
            INCLUDE_DIRECTORIES( ${boost_prefix}/${dir} )
            MESSAGE(STATUS "Found ${boost_prefix}/${dir}")
        ENDIF( IS_DIRECTORY ${boost_prefix}/${dir} )
    ENDFOREACH( dir )
    #
    # add boost link directories
    FOREACH(dir ${cmake_install_libdirs})

=== pkgconfig/CMakeLists.txt ===
# -----------------------------------------------------------------------------
# CppAD: C++ Algorithmic Differentiation: Copyright (C) 2003-21 Bradley M. Bell
#
# CppAD is distributed under the terms of the
#              Eclipse Public License Version 2.0.
#
# This Source Code may also be made available under the following
# Secondary License when the conditions for such availability set forth
# in the Eclipse Public License, Version 2.0 are satisfied:
#       GNU General Public License, Version 2.0 or later.
# -----------------------------------------------------------------------------
# Construct cppad.pc from cppad.pc.in; see
# http://people.freedesktop.org/~dbn/pkg-config-guide.html
# -----------------------------------------------------------------------------
# $begin pkgconfig$$ $newlinech #$$
# $spell
#   CppAD
#   config
#   libdir
#   pkgconfig
#   datadir
#   cppad
#   builddir
#   cmake
#   cflags
#   uninstalled
#   includedir
#   libdirs
# $$
#
# $section CppAD pkg-config Files$$
#
# $head Purpose$$
# The $code pkg-config$$ program helps with the used if installed libraries
# and include files; see its
# $href%https://people.freedesktop.org/~dbn/pkg-config-guide.html%guide%$$
# for more information on writing an using pkg-config files.
#
# $head cppad.pc$$
#
# $subhead PKG_CONFIG_PATH$$
# The $code cppad.pc$$ file is installed in the following two directories:
# $codei%
#   %prefix%/%libdir%/pkgconfig
#   %prefix%/%datadir%/pkgconfig
# %$$
# where $icode prefix$$ is $cref/cppad_prefix/cmake/cppad_prefix/$$,
# $icode libdir$$ is the first entry in
# $cref/cmake_install_libdirs/cmake/cmake_install_libdirs/$$,
# and # $icode datadir$$ is
# $cref/cmake_install_datadir/cmake/cmake_install_datadir/$$.
# In order to use $code pkg-config$$,
# one of these directories must your $code PKG_CONFIG_PATH$$.
#
# $subhead Compile Flags$$
# The necessary flags for compiling code that includes CppAD can
# be obtained with the command
# $codep
#     pkg-config --cflags cppad
# $$
#
# $subhead Link Flags$$
# The flags for linking can be obtains with the command
# $codep
#     pkg-config --libs cppad
# $$
#
# $subhead Extra Definitions$$
# The $code cppad.pc$$ file contains the text:
# $codei%
#   prefix=%prefix%
#   exec_prefix=%exec_prefix%
#   includedir=%includedir%
#   libdir=%libdir%
# %$$
# where $icode prefix$$, $icode exec_prefix$$, $icode includedir$$, and
# $icode libdir$$ are the
# $href%
#   https://www.gnu.org/prep/standards/html_node/Directory-Variables.html%
#   gnu installation variables
# %$$.
#
# $head cppad-uninstalled.pc$$
#
# $subhead PKG_CONFIG_PATH$$
# The $code cppad-uninstalled.pc$$ file is located in the following directory:
# $codei%
#   %builddir%/pkgconfig
# %$$
# where $icode builddir$$ is the directory where the $cref cmake$$ command
# is executed.
#
# $subhead Compile Flags$$
# The necessary flags for compiling code that includes CppAD,
#  before CppAD is installed, can be obtained with the command
# $codep
#     pkg-config --cflags cppad-uninstalled
# $$
#
# $subhead Link Flags$$
# The flags for linking can be obtains with the command
# $codep
#     pkg-config --libs cppad-uninstalled
# $$
#
# $subhead Extra Definitions$$
# The $code cppad-uninstalled.pc$$ file has the same extra variables
# as the $code cppad.pc$$ file.
#
# $end
# ----------------------------------------------------------------------------
#
# The following variables are used by cppad.pc.in
# and set in the top source CMakeLists.txt:
#   cppad_prefix,
#   cppad_description,
#   cppad_version,
#   cppad_url,
#   cppad_lib
# The other variables used by cppad.pc.in are set below
# Note that cppad_SOURCE_DIR is used by cppad-uninstalled.pc
# and is set by cmake to the top soruce directory.
#
# cppad_includedir
LIST(GET cmake_install_includedirs 0 cppad_includedir)
#
# cppad_libdir
LIST(GET cmake_install_libdirs 0 cppad_libdir)
# -----------------------------------------------------------------------------
# initialize
SET(cppad_lib_list "-L${cppad_prefix}/${cppad_libdir} -l${cppad_lib}")
SET(cppad_requires "")
SET(cppad_libs_private "")
SET(cppad_requires_private "")
#
# Colpack does not have a pkgconfig file.
SET(colpack_libdir     NOTFOUND)
IF( cppad_has_colpack )
    FOREACH(dir ${cmake_install_libdirs})
        FILE(GLOB file_list "${colpack_prefix}/${dir}/libColPack.*" )
        IF( file_list )
            SET(colpack_libdir "${colpack_prefix}/${dir}")
        ENDIF( file_list )
    ENDFOREACH(dir ${cmake_install_libdirs})
    IF( NOT colpack_libdir )
        MESSAGE(FATAL_ERROR "Cannit find libColPack.* below ${colpack_prefix}")
    ENDIF( NOT colpack_libdir )
    SET(cppad_lib_list
        "${cppad_lib_list} -L${colpack_libdir} -lColPack"
    )
ENDIF( cppad_has_colpack )
#
# Ipopt has a pkgconfig file.
IF( cppad_has_ipopt )
    SET(cppad_requires          "${cppad_requires} ipopt")
    SET(cppad_lib_list          "${cppad_lib_list} -lcppad_ipopt")
ENDIF( cppad_has_ipopt )
# -----------------------------------------------------------------------------
# cppad.pc
CONFIGURE_FILE(
    ${CMAKE_CURRENT_SOURCE_DIR}/cppad.pc.in
    ${CMAKE_CURRENT_BINARY_DIR}/cppad.pc
    @ONLY
)
# cppad-uninstalled.pc
CONFIGURE_FILE(
    ${CMAKE_CURRENT_SOURCE_DIR}/cppad-uninstalled.pc.in
    ${CMAKE_CURRENT_BINARY_DIR}/cppad-uninstalled.pc
    @ONLY
)
# During install copy cppad.pc to datadir
INSTALL(FILES ${CMAKE_CURRENT_BINARY_DIR}/cppad.pc
    DESTINATION ${cppad_abs_datadir}/pkgconfig
)
# During install also copy cppad.pc to libdir
INSTALL(FILES ${CMAKE_CURRENT_BINARY_DIR}/cppad.pc
    DESTINATION ${cppad_abs_libdir}/pkgconfig
)

=== cppad_ipopt/example/CMakeLists.txt ===
# -----------------------------------------------------------------------------
# CppAD: C++ Algorithmic Differentiation: Copyright (C) 2003-19 Bradley M. Bell
#
# CppAD is distributed under the terms of the
#              Eclipse Public License Version 2.0.
#
# This Source Code may also be made available under the following
# Secondary License when the conditions for such availability set forth
# in the Eclipse Public License, Version 2.0 are satisfied:
#       GNU General Public License, Version 2.0 or later.
# -----------------------------------------------------------------------------
# Inherit build type from ../CMakeList.txt

# Local include directories to search (not in package_prefix/include)
INCLUDE_DIRECTORIES( ${CMAKE_CURRENT_SOURCE_DIR}/../src )

# Local link directories to search (not in external packages)
LINK_DIRECTORIES( ${CMAKE_CURRENT_BINARY_DIR}/../src ${ipopt_LIBRARY_DIRS} )

# add_executable(<name> [WIN32] [MACOSX_BUNDLE] [EXCLUDE_FROM_ALL]
#                 source1 source2 ... sourceN
# )
# BEGIN_SORT_THIS_LINE_PLUS_2
SET(source_list
    example.cpp
    get_started.cpp
    ode_check.cpp
    ode_check.hpp
    ode_fast.hpp
    ode_fast_check.cpp
    ode_problem.hpp
    ode_run.hpp
    ode_simple.hpp
    ode_simple_check.cpp
)
# END_SORT_THIS_LINE_MINUS_2

set_compile_flags( cppad_ipopt_example "${cppad_debug_which}" "${source_list}" )
#
ADD_EXECUTABLE( cppad_ipopt_example EXCLUDE_FROM_ALL ${source_list} )

# List of libraries to be linked into the specified target
TARGET_LINK_LIBRARIES(cppad_ipopt_example
    cppad_ipopt
    ${cppad_lib}
    ${ipopt_LIBRARIES}
    ${colpack_libs}
)

# Add the check_cppad_ipopt_example target
ADD_CUSTOM_TARGET(check_cppad_ipopt_example
    cppad_ipopt_example
    DEPENDS cppad_ipopt_example cppad_ipopt
)
MESSAGE(STATUS "make check_cppad_ipopt_example: available")

# Change check depends in parent environment
add_to_list(check_cppad_ipopt_depends check_cppad_ipopt_example)
SET(check_cppad_ipopt_depends "${check_cppad_ipopt_depends}" PARENT_SCOPE)

=== cppad_ipopt/test/CMakeLists.txt ===
# -----------------------------------------------------------------------------
# CppAD: C++ Algorithmic Differentiation: Copyright (C) 2003-17 Bradley M. Bell
#
# CppAD is distributed under the terms of the
#              Eclipse Public License Version 2.0.
#
# This Source Code may also be made available under the following
# Secondary License when the conditions for such availability set forth
# in the Eclipse Public License, Version 2.0 are satisfied:
#       GNU General Public License, Version 2.0 or later.
# -----------------------------------------------------------------------------
# Build the cppad_ipopt/test directory tests
# Inherit build tyope from ../CMakeList.txt

# Local include directories to search (not in package_prefix/include)
INCLUDE_DIRECTORIES( ${CMAKE_CURRENT_SOURCE_DIR}/../src )

# Local link directories to search (not in external packages)
LINK_DIRECTORIES( ${CMAKE_CURRENT_BINARY_DIR}/../src ${ipopt_LIBRARY_DIRS} )

# add_executable(<name> [WIN32] [MACOSX_BUNDLE] [EXCLUDE_FROM_ALL]
#                 source1 source2 ... sourceN
# )
SET(source_list test_more.cpp
    k_gt_one.cpp
    multiple_solution.cpp
    retape_k1_l1.cpp
    retape_k1_l2.cpp
)
set_compile_flags( cppad_ipopt_test "${cppad_debug_which}" "${source_list}" )
#
ADD_EXECUTABLE( cppad_ipopt_test EXCLUDE_FROM_ALL ${source_list} )

# List of libraries to be linked into the specified target
TARGET_LINK_LIBRARIES(cppad_ipopt_test
    cppad_ipopt
    ${cppad_lib}
    ${ipopt_LIBRARIES}
    ${colpack_libs}
)

# Add the check_cppad_ipopt_test target
ADD_CUSTOM_TARGET(check_cppad_ipopt_test
    cppad_ipopt_test
    DEPENDS cppad_ipopt_test cppad_ipopt
)
MESSAGE(STATUS "make check_cppad_ipopt_test: available")

# Change check depends in parent environment
add_to_list(check_cppad_ipopt_depends check_cppad_ipopt_test)
SET(check_cppad_ipopt_depends "${check_cppad_ipopt_depends}" PARENT_SCOPE)

=== example/multi_thread/CMakeLists.txt ===
# -----------------------------------------------------------------------------
# CppAD: C++ Algorithmic Differentiation: Copyright (C) 2003-18 Bradley M. Bell
#
# CppAD is distributed under the terms of the
#              Eclipse Public License Version 2.0.
#
# This Source Code may also be made available under the following
# Secondary License when the conditions for such availability set forth
# in the Eclipse Public License, Version 2.0 are satisfied:
#       GNU General Public License, Version 2.0 or later.
# -----------------------------------------------------------------------------

# initialize list as empty
SET(check_example_multi_thread_depends "")

# Define the operation
# CHECK_LIBRARY_EXISTS (LIBRARY FUNCTION LOCATION VARIABLE)
#   LIBRARY  - the name of the library you are looking for
#   FUNCTION - the name of the function
#   LOCATION - location where the library should be found
#   VARIABLE - variable to store the result
INCLUDE(CheckLibraryExists)

# If openmp found, set process its subdirectory
IF ( OPENMP_FOUND )
    # OpenMP_CXX_FLAGS - flags to add to the CXX compiler for OpenMP support
    ADD_SUBDIRECTORY(openmp)
ENDIF ( OPENMP_FOUND )

# If pthreads found, set pthread_lib and pthread_lib_path and process subdir
#
# find_library(<VAR> name1 [path1 path2 ...])
SET(pthread_lib "pthread")
FIND_LIBRARY(pthread_lib_path pthread)
MESSAGE(STATUS "pthread library path = ${pthread_lib_path}")
IF ( pthread_lib_path )
    CHECK_LIBRARY_EXISTS(
        pthread pthread_barrier_wait ${pthread_lib_path} pthread_ok
    )
    IF ( pthread_ok )
        ADD_SUBDIRECTORY(pthread)
    ENDIF ( pthread_ok )
ENDIF ( pthread_lib_path )

# Check if boost multi-threading library is avaialble
IF ( Boost_FOUND )
    SET(CMAKE_REQUIRED_DEFINITIONS "")
    SET(CMAKE_REQUIRED_FLAGS       "")
    SET(CMAKE_REQUIRED_INCLUDES    "${Boost_INCLUDE_DIRS}")
    SET(CMAKE_REQUIRED_LIBRARIES   "${Boost_LIBRARIES}")
    SET(source "
# include <boost/thread.hpp>
int main(void)
{   boost::barrier wait(1);
    return 0;
}"
    )
    IF( DEFINED boost_multi_thread_ok )
        MESSAGE( ERROR "boost_multi_thread_ok is defined before expected" )
    ENDIF( DEFINED boost_multi_thread_ok )
    CHECK_CXX_SOURCE_RUNS("${source}" boost_multi_thread_ok )
    #
    IF( boost_multi_thread_ok )
        ADD_SUBDIRECTORY(bthread)
    ENDIF( boost_multi_thread_ok )
    #
ENDIF ( Boost_FOUND )

IF( NOT( "${check_example_multi_thread_depends}" STREQUAL "" ) )
    #
    # check_example_multi_thread
    ADD_CUSTOM_TARGET(
        check_example_multi_thread
        DEPENDS ${check_example_multi_thread_depends}
    )
    MESSAGE(STATUS "make check_example_multi_thread: available")
    #
    # Change check depends in parent environment
    add_to_list(check_depends check_example_multi_thread)
    SET(check_depends "${check_depends}" PARENT_SCOPE)
    #
ENDIF( NOT( "${check_example_multi_thread_depends}" STREQUAL "" ) )

=== example/optimize/CMakeLists.txt ===
# -----------------------------------------------------------------------------
# CppAD: C++ Algorithmic Differentiation: Copyright (C) 2003-19 Bradley M. Bell
#
# CppAD is distributed under the terms of the
#              Eclipse Public License Version 2.0.
#
# This Source Code may also be made available under the following
# Secondary License when the conditions for such availability set forth
# in the Eclipse Public License, Version 2.0 are satisfied:
#       GNU General Public License, Version 2.0 or later.
# -----------------------------------------------------------------------------
# Build the example/optimize directory tests
#
#
# BEGIN_SORT_THIS_LINE_PLUS_2
SET(source_list
    compare_op.cpp
    conditional_skip.cpp
    cumulative_sum.cpp
    forward_active.cpp
    nest_conditional.cpp
    optimize.cpp
    optimize_twice.cpp
    print_for.cpp
    reverse_active.cpp
)
# END_SORT_THIS_LINE_MINUS_2

set_compile_flags( example_optimize "${cppad_debug_which}" "${source_list}" )
#
ADD_EXECUTABLE(example_optimize EXCLUDE_FROM_ALL ${source_list})

# Add the check_example_optimize target
ADD_CUSTOM_TARGET(check_example_optimize
    example_optimize
    DEPENDS example_optimize
)
MESSAGE(STATUS "make check_example_optimize: available")

# add to check check_example_depends in parent environment
add_to_list(check_example_depends check_example_optimize)
SET(check_example_depends "${check_example_depends}" PARENT_SCOPE)

=== speed/profile/CMakeLists.txt ===
# -----------------------------------------------------------------------------
# CppAD: C++ Algorithmic Differentiation: Copyright (C) 2003-20 Bradley M. Bell
#
# CppAD is distributed under the terms of the
#              Eclipse Public License Version 2.0.
#
# This Source Code may also be made available under the following
# Secondary License when the conditions for such availability set forth
# in the Eclipse Public License, Version 2.0 are satisfied:
#       GNU General Public License, Version 2.0 or later.
# -----------------------------------------------------------------------------
# Build the speed/profile directory tests
# Inherit build type from ../CMakeList.txt

# Adds flags to the compiler command line for sources in the current directory
# and below. This command can be used to add any flags, but it was originally
# intended to add preprocessor definitions.
ADD_DEFINITIONS("-DCPPAD_PROFILE_SPEED ${cppad_profile_flag}")

# Extra flags used by the linker when creating an executable.
SET(CMAKE_EXE_LINKER_FLAGS ${cppad_profile_flag})

# Local include directories to search (not in package_prefix/includdir)
INCLUDE_DIRECTORIES( ${CMAKE_CURRENT_SOURCE_DIR}/../src )

# add_executable(<name> [WIN32] [MACOSX_BUNDLE] [EXCLUDE_FROM_ALL]
#                 source1 source2 ... sourceN
# )
SET(source_list ../main.cpp
    ../cppad/det_lu.cpp
    ../cppad/det_minor.cpp
    ../cppad/mat_mul.cpp
    ../cppad/ode.cpp
    ../cppad/poly.cpp
    ../cppad/sparse_hessian.cpp
    ../cppad/sparse_jacobian.cpp
)
set_compile_flags( speed_profile "${cppad_debug_which}" "${source_list}" )
#
ADD_EXECUTABLE( speed_profile EXCLUDE_FROM_ALL ${source_list} )

# profile builds it own copy of src/speed library (see ADD_EXECUTABLE above)
# TARGET_LINK_LIBRARIES(speed_profile speed_src )
TARGET_LINK_LIBRARIES(speed_profile
    speed_src
    ${cppad_lib}
    ${colpack_libs}
)

# Add the check_speed_profile target
ADD_CUSTOM_TARGET(check_speed_profile
    speed_profile correct 54321
    DEPENDS speed_profile
)
MESSAGE(STATUS "make check_speed_profile: available")

# Sed script to make gprof output more readable, use:
#   ./speed_profile speed 54321
#   gprof speed_profile gmon.out | sed -f 'gprof.sed' > gprof.out
#
# configure_file(InputFile OutputFile [COPYONLY] [ESCAPE_QUOTES] [@ONLY])
CONFIGURE_FILE(
    ${CMAKE_CURRENT_SOURCE_DIR}/gprof.sed.in
    ${CMAKE_CURRENT_BINARY_DIR}/gprof.sed
    COPYONLY
)

# Change check depends in parent environment
add_to_list(check_speed_depends check_speed_profile)
SET(check_speed_depends "${check_speed_depends}" PARENT_SCOPE)

=== test_more/cppad_for_tmb/CMakeLists.txt ===
# -----------------------------------------------------------------------------
# CppAD: C++ Algorithmic Differentiation: Copyright (C) 2003-19 Bradley M. Bell
#
# CppAD is distributed under the terms of the
#              Eclipse Public License Version 2.0.
#
# This Source Code may also be made available under the following
# Secondary License when the conditions for such availability set forth
# in the Eclipse Public License, Version 2.0 are satisfied:
#       GNU General Public License, Version 2.0 or later.
# -----------------------------------------------------------------------------
#
# Name for this text
SET(name cppad_for_tmb)
#
# Add extra compiler flags to cppad_cxx_flags so set_compile_flags uses them.
# This change only affects the cppad_for_tmb tests (NO PARENT_SCOPE).
SET(cppad_cxx_flags "${cppad_cxx_flags} ${OpenMP_CXX_FLAGS} -DCPPAD_FOR_TMB")
#
# BEGIN_SORT_THIS_LINE_PLUS_2
SET(source_list
    ${name}.cpp
    implicit_ctor.cpp
    multi_atomic_two.cpp
    multi_atomic_three.cpp
    multi_chkpoint_one.cpp
    multi_chkpoint_two.cpp
    perfer_reverse.cpp
)
# END_SORT_THIS_LINE_MINUS_2

set_compile_flags(
    test_more_${name} "${cppad_debug_which}" "${source_list}"
)
#
# now that we have the properties, add the executable
ADD_EXECUTABLE( test_more_${name} EXCLUDE_FROM_ALL ${source_list} )
#
# Extra flags used by linker for openmp support
SET(CMAKE_EXE_LINKER_FLAGS ${OpenMP_CXX_FLAGS} )
#
# check_test_more_${name} target
ADD_CUSTOM_TARGET(
    check_test_more_${name} test_more_${name} DEPENDS test_more_${name}
)
MESSAGE(STATUS "make check_test_more_${name}: available")

# Add check_test_more_${name} to check depends in parent environment
add_to_list(check_test_more_depends check_test_more_${name})
SET(check_test_more_depends "${check_test_more_depends}" PARENT_SCOPE)

=== test_more/debug_rel/CMakeLists.txt ===
# -----------------------------------------------------------------------------
# CppAD: C++ Algorithmic Differentiation: Copyright (C) 2003-18 Bradley M. Bell
#
# CppAD is distributed under the terms of the
#              Eclipse Public License Version 2.0.
#
# This Source Code may also be made available under the following
# Secondary License when the conditions for such availability set forth
# in the Eclipse Public License, Version 2.0 are satisfied:
#       GNU General Public License, Version 2.0 or later.
# -----------------------------------------------------------------------------
# Build the test_more/general tests

# set compiler flags for debug_rel.cpp and debug.cpp
IF( "${debug_which}" STREQUAL "debug_all" )
    SET(debug_extra    "${CMAKE_CXX_FLAGS_DEBUG}")
    SET(release_extra  "${CMAKE_CXX_FLAGS_DEBUG}")
ELSEIF( "${debug_which}" STREQUAL "debug_none" )
    SET(debug_extra    "${CMAKE_CXX_FLAGS_RELEASE}")
    SET(release_extra  "${CMAKE_CXX_FLAGS_RELEASE}")
ELSE( "${debug_which}" )
    SET(debug_extra    "${CMAKE_CXX_FLAGS_DEBUG}")
    SET(release_extra  "${CMAKE_CXX_FLAGS_RELEASE}")
ENDIF( "${debug_which}" STREQUAL "debug_all" )
#
SET_SOURCE_FILES_PROPERTIES(
    debug_rel.cpp debug.cpp PROPERTIES COMPILE_FLAGS
    "${cppad_cxx_flags} ${debug_extra} -DCPPAD_DEBUG_AND_RELEASE"
)
#
SET_SOURCE_FILES_PROPERTIES(
    release.cpp PROPERTIES COMPILE_FLAGS
    "${cppad_cxx_flags} ${release_extra} -DCPPAD_DEBUG_AND_RELEASE"
)

# now that we have the properties, add the executable
ADD_EXECUTABLE(test_more_debug_rel EXCLUDE_FROM_ALL
    debug_rel.cpp
    debug.cpp
    release.cpp
)

# Add the check_test_more_debug_rel target
ADD_CUSTOM_TARGET(check_test_more_debug_rel
    test_more_debug_rel
    DEPENDS
    test_more_debug_rel
)
MESSAGE(STATUS "make check_test_more_debug_rel: available")

# Change check depends in parent environment
add_to_list(check_test_more_depends check_test_more_debug_rel)
SET(check_test_more_depends "${check_test_more_depends}" PARENT_SCOPE)

=== test_more/deprecated/chkpoint_one/CMakeLists.txt ===
# -----------------------------------------------------------------------------
# CppAD: C++ Algorithmic Differentiation: Copyright (C) 2003-19 Bradley M. Bell
#
# CppAD is distributed under the terms of the
#              Eclipse Public License Version 2.0.
#
# This Source Code may also be made available under the following
# Secondary License when the conditions for such availability set forth
# in the Eclipse Public License, Version 2.0 are satisfied:
#       GNU General Public License, Version 2.0 or later.
# -----------------------------------------------------------------------------
#
# BEGIN_SORT_THIS_LINE_PLUS_2
SET(source_list
    chkpoint_one.cpp
    extended_ode.cpp
    get_started.cpp
    mul_level.cpp
    ode.cpp
)
# END_SORT_THIS_LINE_MINUS_2

set_compile_flags(test_more_deprecated_chkpoint_one
    "${cppad_debug_which}" "${source_list}"
)
#
ADD_EXECUTABLE(test_more_deprecated_chkpoint_one
    EXCLUDE_FROM_ALL ${source_list}
)
#
# Add the check_test_more_deprecated_chkpoint_one target
ADD_CUSTOM_TARGET(check_test_more_deprecated_chkpoint_one
    test_more_deprecated_chkpoint_one
    DEPENDS test_more_deprecated_chkpoint_one
)
MESSAGE(STATUS "make check_test_more_deprecated_chkpoint_one: available")
#
# add to check check_test_more_deprecated_depends in parent environment
add_to_list(check_test_more_deprecated_depends
    check_test_more_deprecated_chkpoint_one
)
SET(check_test_more_deprecated_depends
    "${check_test_more_deprecated_depends}" PARENT_SCOPE
)

=== debian/changelog ===
cppad (2021.00.00.8-1) unstable; urgency=medium

  * New upstream release

 -- Barak A. Pearlmutter <bap@debian.org>  Mon, 27 Sep 2021 13:38:29 +0100

cppad (2021.00.00.7-1) unstable; urgency=medium

  * New upstream release

 -- Barak A. Pearlmutter <bap@debian.org>  Tue, 17 Aug 2021 17:43:28 +0100

=== debian/control ===
Source: cppad
Section: devel
Priority: optional
Maintainer: Debian Science Team <debian-science-maintainers@alioth-lists.debian.net>
Uploaders: Miles Lubin <miles.lubin@gmail.com>,
           Barak A. Pearlmutter <bap@debian.org>
Build-Depends: debhelper-compat (= 13), cmake, libboost-all-dev
Standards-Version: 4.6.0
Rules-Requires-Root: no
Homepage: https://projects.coin-or.org/CppAD/
Vcs-Git: https://salsa.debian.org/science-team/cppad.git
Vcs-Browser: https://salsa.debian.org/science-team/cppad

Package: libcppad-lib340.3
Section: libs
Architecture: any
Multi-Arch: same
Depends: ${shlibs:Depends}, ${misc:Depends}
Conflicts: cppad (<< 2020.00.00.0)
Description: Automatic Differentiation of C++ algorithms, shared library
 CppAD is a package for automatic differentiation (AD) of algorithms
 written in C++.  Given appropriately written C++ code that computes a
 function, CppAD augments it to also compute derivative values.  The
 system uses templates, supports forward and reverse accumulation
 modes, and allows nested derivatives.
 .
 This package contains runtime support, including shared libraries.

Package: libcppad-dev
Section: libdevel
Architecture: any
Multi-Arch: same
Depends: ${shlibs:Depends}, ${misc:Depends}, libcppad-lib340.3 (= ${binary:Version})
Conflicts: cppad (<< 2020.00.00.0)
Description: Automatic Differentiation of C++ algorithms, dev files
 CppAD is a package for automatic differentiation (AD) of algorithms
 written in C++.  Given appropriately written C++ code that computes a
 function, CppAD augments it to also compute derivative values.  The
 system uses templates, supports forward and reverse accumulation
 modes, and allows nested derivatives.
 .
 This package contains development file: C++ headers and development
 libraries.

Package: libcppad-doc
Section: doc
Architecture: all
Multi-Arch: foreign
Depends: ${misc:Depends}
Conflicts: cppad (<< 2020.00.00.0)
Description: Automatic Differentiation of C++ algorithms, documentation
 CppAD is a package for automatic differentiation (AD) of algorithms
 written in C++.  Given appropriately written C++ code that computes a
 function, CppAD augments it to also compute derivative values.  The
 system uses templates, supports forward and reverse accumulation
 modes, and allows nested derivatives.
 .
 This package contains documentation.

Package: cppad
Architecture: all
Depends: libcppad-dev, ${misc:Depends}
Description: Automatic Differentiation of C++ algorithms, dummy package
 CppAD is a package for automatic differentiation (AD) of algorithms
 written in C++.  Given appropriately written C++ code that computes a
 function, CppAD augments it to also compute derivative values.  The
 system uses templates, supports forward and reverse accumulation
 modes, and allows nested derivatives.
 .
 This transition package helps with the move to libcppad-dev.

=== debian/rules ===
#!/usr/bin/make -f

export DEB_BUILD_MAINT_OPTIONS = hardening=+all

%:
	dh $@ --buildsystem=cmake --without autoreconf
# adding --without autotools-dev breaks dh_auto_install (!)

override_dh_autotools-dev_updateconfig:
	@echo "using cmake so no need to fiddle with config.guess or config.sub"

override_dh_autotools-dev_restoreconfig:
	@echo "using cmake so no need to fiddle with config.guess or config.sub"

# Depending on how the package evolves, it might make sense at some
# point to make these package into build dependencies:
#
#	libadolc-dev
#	libcolpack-dev
#	coinor-libipopt-dev
#	libtrilinos-sacado-dev
#	libeigen3-dev
#
# and to enable them with something like this:
#
# override_dh_auto_configure:
#	dh_auto_configure --		\
#		-D adolc_prefix=/usr	\
#		-D colpack_prefix=/usr	\
#		-D ipopt_prefix=/usr	\
#		-D sacado_prefix=/usr	\
#		-D eigen_prefix=/usr

=== debian/watch ===
# See uscan(1) for format
version=4

https://github.com/coin-or/CppAD/releases \
 .*/(\d\d\d\d)(\d\d)(\d\d)\.(\d+)\.tar\.gz
